
#include "catch.hpp"
#include "size_map.h"
#include "shm_manager.h"

TEST_CASE("SizeMap, CalcAlignment")
{
    for(size_t i = 0; i < CLASS_MAX_BYTES; ++i)
    {
        auto value = bg::detail::SizeMap::CalcAlignment(i);
        REQUIRE(value > 0);
        REQUIRE(value % 8 == 0);
        REQUIRE(value <= CALIGNMENT_MAX_BYTES);
        if(i > 0x7F && i < (CALIGNMENT_MAX_BYTES << 4))
        {
            REQUIRE(PALIGN_DOWN(i, value << 3) == value << 3);
        }
    }
}


TEST_CASE("SizeMap, Class Index to Page")
{
    bg::detail::SizeMap sizemap;
    sizemap.Init();
    for(size_t bytes = 0; bytes < CLASS_MAX_BYTES; ++bytes)
    {

        size_t index;
        if(bytes <= BYTES_COMP_VALUE)
        {
            index = sizemap.m_index_to_class[SMALL_BYTES_TO_INDEX(bytes)];
        }
        else
        {
            auto temp1 = BIG_BYTES_TO_INDEX(bytes);
            index = sizemap.m_index_to_class[BIG_BYTES_TO_INDEX(bytes)];
        }

        REQUIRE(index < CLASS_MAX_COUNT);
        REQUIRE(sizemap.m_class_to_size[index] >= bytes);
        REQUIRE(sizemap.m_class_to_pages[index] * CALIGNMENT_MAX_BYTES >= bytes);
        REQUIRE(sizemap.m_class_to_pages[index] * CALIGNMENT_MAX_BYTES <= CLASS_MAX_BYTES);

    }
}